<?php
putenv("KRB5CCNAME={$_SERVER['KRB5CCNAME']}");

function isDomainUser() {
    $processUser = posix_getpwuid(posix_geteuid());
    $users = array();
    exec("ald-admin user-list", $users);
    return in_array($processUser['name'], $users);
}

if(isDomainUser()) {
    putenv("ALD_DOMAIN=1");
}

$outProtocolDir = "/var/www/printcontrol/protocol/";

$newPrintJobList = <<<XML
<?xml version='1.0' encoding='UTF-8'?>
<PrintJobList>
</PrintJobList>
XML;

$newPrintJobList = <<<XML
<?xml version='1.0' encoding='UTF-8'?>
<?xml-stylesheet type="text/xsl" href="printcontrol.xsl" media="screen"?>
<PrintJobList>
</PrintJobList>
XML;

$newProtocol = <<<XML
<?xml version='1.0' encoding='UTF-8'?>
<Protocol>
</Protocol>
XML;

function getLevelName() {
	$l = array();
	exec ('/usr/sbin/userlev', $l); # Получение списка уровней доступа
	$level = array();
	for ($i=0; $i<count($l); $i++) {
		$ll = array();
		$ll = explode("  ", $l[$i]);
		$level[$ll[0]] = str_replace('_',' ',$ll[1]);
	}
	return $level;
}

function getUserInfo () {
	$u = array();
	exec ('getent passwd', $u); # Получение параметров пользователя
	$user = array();
	for ($i=0; $i<count($u); $i++) {
		$uu = array();
		$uu = explode(":", $u[$i]);
		$uuu = array();
		$uuu = explode(",", $uu[4]);
		$user[$uu[0]]["name"] = $uuu[0];
		if (count($uuu)>1) $user[$uu[0]]["dislocation"] = $uuu[1];
		if (count($uuu)>2) $user[$uu[0]]["phone"] = $uuu[2];
	}
	return $user;
}

function getJobAttr($ID) {
	$jobattr = array();
	$attr = array();
	exec ("lpattr -j ".$ID, $attr); # Получаем атрибуты задания
	if (in_array("job-name=", $attr)) {
		exec ("lpattr -j ".$ID." -s job-name=Безымянный");
		$attr = array();
		exec ("lpattr -j ".$ID, $attr); # Получаем атрибуты задания
	}
	for ($j=0; $j<count($attr); $j++) {
		$pp = array();
		$pp = explode("=", $attr[$j]); # Разбиваем строку атрибута на имя и значение
		$jobattr[$pp[0]] = $pp[1]; # Формируем массив атрибутов
	}
	return $jobattr;
}

function makeJobNode($Job, $p, $user, $level) {

	foreach ($p as $name=>$value) $Job[$name] = $value;

	$job_originating_user_name = $Job->addChild("job-originating-user-name");
	$u = explode("@", $p["job-originating-user-name"]); # Разделение идентификаторов пользователя и домена 
	$job_originating_user_name["login"] = $u[0];
	if (count($u) > 1) $job_originating_user_name["domen"] = $u[1];
	foreach ($user[$u[0]] as $name=>$value) $job_originating_user_name[$name] = $value;

	$mac_job_mac = $Job->addChild("mac-job-mac");
	$l = explode(":", $p["mac-job-mac"]); # Разделение уровня и категории доступа 
	$mac_job_mac["level"] = $level[$l[0]];

	$time_at_creation = $Job->addChild("time-at-creation");
	$time_at_creation["date"] = date("d.m.Y", $p["time-at-creation"]);
	$time_at_creation["time"] = date("H:i:s", $p["time-at-creation"]);

	return $Job;
}

///////////////////////////////////////////////////////////

$parm = array_flip($_POST);

$level = getLevelName(); # Получение списка уровней доступа
$user = getUserInfo(); # Получение данных о пользователях

///// СОЗДАНИЕ НАЧАЛЬНОЙ XML-СТРУКТУРЫ /////
$PrintJobList = new SimpleXMLElement($newPrintJobList);

$user_prn = $PrintJobList->addChild("user-prn");
$u = explode("@", $_SERVER["REMOTE_USER"]); # Разделение идентификаторов пользователя и домена 
$user_prn["login"] = $u[0];
if (count($u) > 1) $user_prn["domen"] = $u[1];
foreach ($user[$u[0]] as $name=>$value) $user_prn[$name] = $value;

///// ОТРАБОТКА УПРАВЛЯЮЩИХ ВОЗДЕЙСТВИЙ /////

if (array_key_exists("Удалить", $parm)) {
	exec ("cancel ".$parm["Удалить"], $aa, $code);
}

if (array_key_exists("Печать", $parm)) {
	exec ("lp -i ".$parm["Печать"]." -H resume", $aa, $code);
	sleep (2);
}

if (array_key_exists("Отправить", $parm)) {
	$p = getJobAttr($_POST["job-id"]);
	$l = explode(":", $p["mac-job-mac"]); # Разделение уровня и категории доступа 
	exec ("lpattr -j ".$_POST["job-id"].' -s "stepen='."'".$level[$l[0]]."'".'"');
	exec ("lpattr -j ".$_POST["job-id"].' -s "punkt='."'".$_POST["punkt"]."'".'"');
	exec ("lpattr -j ".$_POST["job-id"].' -s "user-fullname='."'".$_POST["user-fullname"]."'".'"');
	exec ("lpattr -j ".$_POST["job-id"].' -s "printuser-fullname='."'".$_POST["printuser-fullname"]."'".'"');
	exec ("lpattr -j ".$_POST["job-id"]." -s copies=".$_POST["copies"]);
	exec ("lpattr -j ".$_POST["job-id"]." -s mac-inv-num=".$_POST["mac-inv-num"]);
	exec ("lpattr -j ".$_POST["job-id"].' -s "mac-owner-phone='."'".$_POST["mac-owner-phone"]."'".'"');
	exec ("lpattr -j ".$_POST["job-id"]." -s mac-workplace-id=".$_POST["mac-workplace-id"]);
	$adr = "'".$_POST["adr1"];
	if ($_POST["adr2"] != "") $adr = $adr."^".$_POST["adr2"];
	if ($_POST["adr3"] != "") $adr = $adr."^".$_POST["adr3"];
	if ($_POST["adr4"] != "") $adr = $adr."^".$_POST["adr4"];
	if ($_POST["adr5"] != "") $adr = $adr."^".$_POST["adr5"];
	$adr = $adr."'";
	exec ("lpattr -j ".$_POST["job-id"].' -s "mac-distribution='.$adr.'"');
	exec ("lpattr -j ".$_POST["job-id"]." -m");
	sleep (2);

	$Protocol = new SimpleXMLElement($newProtocol);
	$Protocol["job-id"] = $_POST["job-id"];
	$Protocol["mac-job-user-name"] = $user_prn["login"];
	$outProtocolFile = $outProtocolDir.$_POST["job-id"].".tmp";
	$Protocol->asXML($outProtocolFile);
}

if (array_key_exists("Запомнить", $parm)) {
	$Protocol = new SimpleXMLElement($newProtocol);
	foreach ($_POST as $name=>$value) if ($value != "Запомнить") $Protocol[$name] = $value;

	$p = getJobAttr($Protocol["job-id"]);
	$PrintJob = $Protocol->addChild("PrintJob");
	$PrintJob = makeJobNode($PrintJob, $p, $user, $level);

	$outxmlfile = $outProtocolDir.sprintf("%05d",$_POST["job-id"]).".xml";
	$Protocol->asXML($outxmlfile);
	exec ("rm ".$outProtocolDir.$_POST["job-id"].".tmp");
}

if (array_key_exists("Не запоминать", $parm)) {
	exec ("rm ".$outProtocolDir.$_POST["job-id"].".tmp");
}

///// ФОРМИРОВАНИЕ XML-СТРУКТУРЫ /////
$PrintJobList["date"] = date("d.m.Y");
$PrintJobList["time"] = date("H:i:s");

$Protocol = $PrintJobList->addChild("Protocol");
$PrintJobList->addChild("PrintJob");
$PrintJobList->addChild("PrintList");
$PrintJobList->addChild("JobList");

$a = array();
#exec ("ls ".$outProtocolDir."*.tmp", $a); # Получение списка проектов протоколов
$a = glob($outProtocolDir."*.tmp"); # Получение списка проектов протоколов
for ($i=0; $i<count($a); $i++) {
	$xml = simplexml_load_file($a[$i]);
	if ((string)$xml["mac-job-user-name"] == (string)$user_prn["login"]) {
		foreach ($xml->attributes() as $name=>$value) $Protocol[$name] = $value;
		$p = getJobAttr($Protocol["job-id"]);
		$PrintJob = $Protocol->addChild("PrintJob");
		$PrintJob = makeJobNode($PrintJob, $p, $user, $level);
	}
}

$a = array();
exec ("lpq -a", $a); # Получение списка заданий на печать
if ($a[0] != "no entries") {
	for ($i=1; $i<count($a); $i++) {
		$aa = ltrim(rtrim(trim(preg_replace("/\s{2,}/", " ", $a[$i])))); # Убираем лишние пробелы в строке
		$p = array();
		$p = explode(" ", $aa, 8); # Разбиваем строку на поля
		$ID = $p[2]; # Определяем идентификатор задания
		$p = getJobAttr($ID);
		if ($p["job-state"] == 4) {

			if (array_key_exists("mac-job-user-name", $p)) $mac_job_user_name = explode("@", $p["mac-job-user-name"]);
			else unset($mac_job_user_name);

			if (array_key_exists("Выбрать", $parm) && ((string)$p["job-id"] == (string)$parm["Выбрать"])) {
				$Job = $PrintJobList->PrintJob;
			} elseif (isset($mac_job_user_name) && ((string)$mac_job_user_name[0] == (string)$user_prn["login"])) {
				$Job = $PrintJobList->PrintJob;
			} elseif (array_key_exists("mac-job-origin", $p) && ((string)$p["mac-job-origin"] == (string)$PrintJobList->PrintJob["job-id"])) {
				$Job = $PrintJobList->PrintList->addChild("Job");
				$job_name = $Job->addChild("job-name");
				$n = explode(":", $p["job-name"]);
				if (strspn($n[0], "mac(") == 4) $job_name["type"] = "document";
				else $job_name["type"] = "rekvizit";
				$nn = explode("/", $n[1]);
				$job_name["copie"] = $nn[0];
			} else {
				$Job = $PrintJobList->JobList->addChild("Job");
			}
			$Job = makeJobNode($Job, $p, $user, $level);
		}
	}
}

if ((count($PrintJobList->PrintJob->Attributes()) != 0)
&& isset($PrintJobList->PrintJob["mac-job-user-name"])
&& (count($PrintJobList->PrintList->Children()) == 0)) {
	unset($PrintJobList->PrintJob);
	$PrintJobList->addChild("PrintJob");
}

if (count($PrintJobList->PrintJob->Attributes()) == 0) {
	if (count($PrintJobList->Protocol->Attributes()) == 0) {
		if (count($PrintJobList->JobList->Children()) == 0) {
			$PrintJobList["step"] = 0;
		} else {
			$PrintJobList["step"] = 1;
		}	
	} else {
		$PrintJobList["step"] = 4;
	}
} else {
	if (count($PrintJobList->PrintList->Children()) == 0) {
		$PrintJobList["step"] = 2;
	} else {
		$PrintJobList["step"] = 3;
	}
}

#$PrintJobList->asXML("../protocol/PrintJobList.xml");

header("Content-Type: text/xml");
echo $PrintJobList->asXML();
?>
