<?php
putenv("KRB5CCNAME={$_SERVER['KRB5CCNAME']}");

$outProtocolDir = "/var/www/printcontrol/protocol/";

$newProtocolList = <<<XML
<?xml version='1.0' encoding='UTF-8'?>
<?xml-stylesheet type="text/xsl" href="protocol.xsl" media="screen"?>
<ProtocolList>
</ProtocolList>
XML;

$ProtocolList = new SimpleXMLElement($newProtocolList);

$ProtocolList->addAttribute('DateTime', date("H:i:s d.m.Y"));

$tmp = glob($outProtocolDir."*.xml"); # Получение списка протоколов
rsort($tmp);
reset($tmp);

for ($n=0; $n<count($tmp); $n++) {
	$xml = simplexml_load_file($tmp[$n]);
	$Protocol = $ProtocolList->addChild('Protocol');
	foreach ($xml->attributes() as $name=>$value) $Protocol[$name] = $value;
	$PrintJob = $Protocol->addChild('PrintJob');
	foreach ($xml->PrintJob->attributes() as $name=>$value) $PrintJob[$name] = $value;
	foreach ($xml->PrintJob->children() as $cname=>$cvalue) {
		$Child = $Protocol->addChild($cname);
		foreach ($cvalue->attributes() as $name=>$value) $Child[$name] = $value;
	}
}

#$ProtocolList->asXML("Protocol.xml");
header('Content-Type: text/xml');
echo $ProtocolList->asXML();
?>
